# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Test2-Plugin-NoWarnings
Version:	0.05
Release:	1.%{__distinit}%{__distvers}
Summary:	Fail if tests warn
License:	Artistic 2.0
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Test2-Plugin-NoWarnings/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DR/DROLSKY/Test2-Plugin-NoWarnings-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(parent)
BuildRequires:	perl(strict)
BuildRequires:	perl(Test2::API)
BuildRequires:	perl(Test2::Event)
BuildRequires:	perl(Test2::Util::HashBase)
BuildRequires:	perl(warnings)
# Test Suite (wants Test::More ≥ 0.96 but 0.62 works fine)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(IPC::Run3)
BuildRequires:	perl(Test2::Bundle::Extended)
BuildRequires:	perl(Test2::Require::Module)
BuildRequires:	perl(Test::More)
# Optional Tests
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(CPAN::Meta::Prereqs)
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
Loading this plugin causes your tests to fail if there are any warnings while
they run. Each warning generates a new failing test and the warning content is
outputted via diag.

This module uses $SIG{__WARN__}, so if the code you're testing sets this, then
this module will stop working.

%prep
%setup -q -n Test2-Plugin-NoWarnings-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes README.md
%{perl_vendorlib}/Test2/
%{_mandir}/man3/Test2::Event::Warning.3*
%{_mandir}/man3/Test2::Plugin::NoWarnings.3*

%changelog
* Tue Nov  8 2016 Paul Howarth <paul@city-fan.org> - 0.05-1
- Update to 0.05
  - Skip compile.t on Windows; this test uses IPC::Run3, which doesn't seem to
    work well on that platform (CPAN RT#118443)

* Thu Oct 27 2016 Paul Howarth <paul@city-fan.org> - 0.04-2
- We provide Test2::Event::Warning so we don't need to build-require it

* Mon Oct 24 2016 Paul Howarth <paul@city-fan.org> - 0.04-1
- Update to 0.04
  - Load Test2::Event::Warning in the plugin instead of relying on Test2 to do
    it for us; this should avoid the bug fixed in the previous version and
    eliminates the need for the INIT block, which caused its own problems

* Tue Oct 18 2016 Paul Howarth <paul@city-fan.org> - 0.03-1
- Update to 0.03
  - Add the $SIG{__WARN__} hook in an INIT block; we really don't want to
    trigger this because of a compile-time warning, and because of a bug in
    Test::Builder, this can actually cause the warning to be lost entirely
    (https://github.com/Test-More/test-more/issues/729)
  - The Test2::Event::Warning event now returns true for increments_count,
    which means that the test failure caused by a warning will not be output
    as a TAP test line; previously this was just seen as a diag line, which
    could be quite confusing
    (https://github.com/Test-More/test-more/issues/728)

* Sun Sep 18 2016 Paul Howarth <paul@city-fan.org> - 0.02-1
- Initial RPM version
